#include <EEPROM.h>
//#include <Servo.h>

#include <DNSServer.h>            //Local DNS Server used for redirecting all requests to the configuration portal
#include <ESP8266WebServer.h>     //Local WebServer used to serve the configuration portal
#include <WiFiManager.h>          //https://github.com/tzapu/WiFiManager WiFi Configuration Magic

#include <ESP8266WiFi.h>
#include <WiFiServer.h>
#include <WiFiUdp.h>
#include <ESP8266WiFiScan.h>
#include <WiFiClient.h>
#include <ESP8266WiFiGeneric.h>
#include <ESP8266WiFiAP.h>
#include <WiFiClientSecure.h>
#include <ESP8266WiFiType.h>
#include <ESP8266WiFiMulti.h>
#include <ESP8266WiFiSTA.h>

#define MINECRAFT

char host[60];
#ifdef MINECRAFT
char portc[] = "25565";
int Port = 25565;
#else
char portc[] = "27015";
int Port = 27015;
#endif
WiFiManager wifiManager;
char data[128] = {255, 255, 255, 255, 84, 83, 111, 117, 114, 99, 101, 32, 69, 110, 103, 105, 110, 101, 32, 81, 117, 101, 114, 121, 0};
char data2[] = {0x01, 0x00};
int lengde = 0;
int i = 0;
int online = 0;
int maks = 10;
WiFiUDP Udp;
//Servo myservo;


void Viser(int serpos){

  //    myservo.write(135-serpos*6/10);
  //    delay(5000);

  //Make a puls 1-2ms long to controll servo. Did not get servo.h to work so made it this way. It doubbles as a delay of 5 seconds before next check of server
  int i = 0;
  while (i < 10) {
    i++;
    noInterrupts();
    digitalWrite(2, HIGH);
    //      delayMicroseconds(1900-serpos*8);
    unsigned long tid = micros() + 1900 - serpos * 8;
    while (tid >= micros()) {
      if (micros() < 2000) {
        tid = 0;
        i = 4;
      }
    }
    digitalWrite(2, LOW);
    interrupts();
    delay(100);
  }
}


void setup() {
  // put your setup code here, to run once:
  Serial.begin(115200);
  pinMode(0, INPUT);
  pinMode(2, OUTPUT);
  delay(15);
  
  rst_info *resetInfo;
  resetInfo = ESP.getResetInfoPtr();
  int resreason = (*resetInfo).reason;
  Serial.print("Boot reason: ");
  Serial.println(resreason);

/*  
0 normal startup by power on 
1 hardware watch dog reset
2 exception reset, GPIO status won’t change
3 software watch dog reset, GPIO status won’t change
4 software restart ,system_restart , GPIO status won’t change
5 wake up from deep-sleep
6 external system reset
*/
  
  digitalWrite(2, LOW);
  // 5 sekonds to check for button press. if button is pressed then reset wifi and ask for setup via AP But only after poweron
if (resreason == 0 || resreason == 6){
  while (i < 50) {
    if (i<31) delay(100);
    i++;
    switch (i){
      case 1 : Viser(-20);break;
      case 11 : Viser(-5);break;
      case 21 : Viser(100);break;
    }
    if (i>31){
      Viser(250-i*5);
    }
    if ( digitalRead(0) == LOW ) {
      wifiManager.resetSettings();
      WiFi.disconnect();
      delay(1000);
      i = 60;
      Viser(45);
      delay(4000);
    }
    Serial.println(i);
  }
}

  // Read minecraft server adress and portnr from EEPROM. But only if eprom starts with MC
  EEPROM.begin(128);
  if ((uint8_t)EEPROM.read(0) == 77) {
    if ((uint8_t)EEPROM.read(1) == 67) {
      Port = (uint8_t)EEPROM.read(2) * 256 + (uint8_t)EEPROM.read(3);
      i = 0;
      while ((uint8_t)EEPROM.read(4 + i) != 0) {
        host[i] = (uint8_t)EEPROM.read(4 + i);
        i++;
      }
      host[i] = 0;
      Serial.print(host);
      Serial.print(":");
      Serial.println(Port);
      itoa(Port, portc, 10);
    }
  }

  //Start wifimanager. Wifimanager manages connection to wifi
#ifdef MINECRAFT
  WiFiManagerParameter custom_server("server", "Minecraft server", host, 40);
#else
  WiFiManagerParameter custom_server("server", "Steam server", host, 40);
#endif
  WiFiManagerParameter custom_port("port", "server port", portc, 6);

  wifiManager.addParameter(&custom_server);
  wifiManager.addParameter(&custom_port);

  int Portb = Port;

  if (wifiManager.autoConnect("MCViser")) {
    // decode portsetting to Port variable and save settings in EEPROM if it is changed
    strcpy(host, custom_server.getValue());
    strcpy(portc, custom_port.getValue());
    Port = atoi(portc);
    int pu = Port / 256;
    EEPROM.write(0, (uint8_t) 77);  //M
    EEPROM.write(1, (uint8_t) 67);  //C
    EEPROM.write(2, (uint8_t) pu);
    EEPROM.write(3, (uint8_t) Port % 256);
    int CH = 0;
    for (i = 0; i <= strlen(host); i++)
    {
      if ((uint8_t)EEPROM.read(4 + i) != host[i]) {
        EEPROM.write(i + 4, (uint8_t) host[i]);
        CH++;
      }
    }
    EEPROM.write(i + 5, (uint8_t) 0);
    if ((Portb != Port) || (CH > 0)) {
      // saving only if it is changed
      EEPROM.commit();
      Serial.println("Saved settings to EEProm");
    }
  }

  // data[] array contains tcp packet to send to Minecraft server to do a Ping (Gets MOTD, online, max, image etc in return)
#ifdef MINECRAFT
  data[0] = sizeof(host) + 6; // Lengde på data (adr + 6)
  data[1] = 0;  // Pakke id/type
  data[2] = 0xbc; // 2 byte protokoll 316 (varint)
  data[3] = 0x02;
  data[4] = sizeof(host) - 1; // Lengde på adresse
  for (i = 0; i < sizeof(host); i++) {
    data[5 + i] = host[i];
  }
  data[i + 4] = Port / 256; // portnr 16bit
  data[i + 5] = Port % 256;
  data[i + 6] = 1;    //Alltid 1
  lengde = i + 7;
#else
  //  data[]= {255,255,255,255,84,83,111,117,114,99,101,32,69,110,103,105,110,101,32,81,117,101,114,121,0};
  lengde = 25;
#endif

  //  myservo.attach(2);
  //  myservo.write(135);

}

void loop() {
  // put your main code here, to run repeatedly:

#ifdef MINECRAFT
  // Use WiFiClient class to create TCP connections
  WiFiClient client;
  if (!client.connect(host, Port)) {
    Serial.println("connection failed");
    delay(1000);
    return;
    online = -2;
    maks = 10;
  }
  else
  {
    //Sending 2 packets
    client.write(&data[0], lengde); //sizeof(data));
    delay(10);

    while (client.available()) {
      char c = client.read();
    }

    
    client.write(&data2[0], sizeof(data2)); //sizeof(data));
    delay(1000);

    // reciving and decoding json response from server
    String line = "";
    // find line with "online"
    while (client.available() && !strstr (line.c_str(), "online")) {
      line = client.readStringUntil('}');
      Serial.println(line);
    }
    maks = atoi(strstr (line.c_str(), "max\":") + 5);
    online = atoi(strstr (line.c_str(), "online\":") + 8);
    //Empty rest of buffer
    while (client.available()) {
      char c = client.read();
    }

    if (!client.connected()) {
      Serial.println();
      Serial.println("disconnecting.");
      client.stop();
    }
  }

#else
  Udp.begin(27016);

  Udp.beginPacket(host, Port);
  Udp.write(&data[0], lengde);
  Udp.endPacket();

  delay(1000);

  int packetSize = Udp.parsePacket();
  if (packetSize)
  {
    // receive incoming UDP packets
    Serial.printf("Received %d bytes from %s, port %d\n", packetSize, Udp.remoteIP().toString().c_str(), Udp.remotePort());
    char incomingPacket[255];  // buffer for incoming packets
    int len = Udp.read(incomingPacket, 255);
    if (len > 0)
    {
      incomingPacket[len] = 0;
      int pos = 4;
      int t = 0;
      Serial.print("len: ");
      Serial.println(len);

      while ((t < 4) && (pos < 240) && (pos < (len - 4))) {
        pos++;
        if (incomingPacket[pos] == 0) t++;
        Serial.print(incomingPacket[pos]);
      }
      Serial.print(" pos: ");
      Serial.println(pos);
      pos = pos + 3;
      online = incomingPacket[pos];
      maks = incomingPacket[pos + 1];
    }
    //    Serial.printf("UDP packet contents: %s\n", incomingPacket);
  }
  else {
    online = -2;
    maks = 10;
  }
  Udp.stop();



#endif
  if (maks == 0) {
    online = -2;
    maks = 10;
  }
  //Send data to serial
  Serial.print(host);
  Serial.print(":");
  Serial.println(Port);
  Serial.print("Online: ");
  Serial.print(online);
  Serial.print("/");
  Serial.print(maks);
  // calculate % full, used for servo
  int serpos = 100 * online / maks;
  if (serpos >= 100) {
    serpos = 100;
  }
  // If any error (server offline) point at red mark.
  if (serpos < 0) {
    serpos = -20;
  }
  // If zero online, go a little extra down to make that easy to detect
  if (serpos == 0) {
    serpos = -5;
  }
  Serial.print(" ");
  Serial.print(serpos);
  Serial.println("%");

  Viser(serpos);

  delay(4000);
}
